﻿local RSwapper3 = LibStub("AceAddon-3.0"):GetAddon("RSwapper3");
local L = LibStub("AceLocale-3.0"):GetLocale("RSwapper3", true);
local RS3GUI = RSwapper3.RS3GUI;

local ldb = LibStub:GetLibrary("LibDataBroker-1.1");
RSwapper3.DataObj = ldb:NewDataObject("RSwapper3", {type = "data source", icon = "Interface\\Icons\\Ability_Stealth", text = L["|cffff0000[Disabled]|r"], label = "RSwapper3", tocname = "RSwapper3"});

local dataobj = RSwapper3.DataObj;

function dataobj:OnTooltipShow()
	self:AddLine("RSwapper3");
	self:AddLine(" ");

	self:AddLine(dataobj.text);
	if (RSwapper3.DOTip) then
		self:AddLine(RSwapper3.DOTip);
	end
	if (not RSwapper3.ISCHARROGUE) then
		return;
	end
	
	self:AddLine(" ");
	
	self:AddLine("/RSwapper3");
	self:AddLine(format("%s: %s", SOUND_LABEL, ((RSwapper3.db.char.Sound and L["|cff00ff00[On]|r"]) or L["|cffff0000[Off]|r"])));
	if (RSwapper3.db.char.Dagger) then
		self:AddLine(format("%s: %s", L["Dagger"], RSwapper3.db.char.Dagger));
	else
		self:AddLine(format("%s: %s", L["Dagger"], L["|cffff0000[Not Set]|r"]));
	end
	if (RSwapper3.db.char.Sword) then
		self:AddLine(format("%s: %s", L["Sword"], RSwapper3.db.char.Sword));
	else
		self:AddLine(format("%s: %s", L["Sword"], L["|cffff0000[Not Set]|r"]));
	end
	if (RSwapper3.db.char.Offhand) then
		self:AddLine(format("%s: %s", L["Offhand"], L["|cff00ff00[Checking Off-Hand then in Bags]|r"]));
	else
		self:AddLine(format("%s: %s", L["Offhand"], L["|cff996633[Checking only in Bags]|r"]));
	end
	if (RSwapper3.db.char.Stealth) then
		self:AddLine(format("%s: %s", L["Stealth"], L["|cff666666[Swapping only in stealth!]|r"]));
	else
		self:AddLine(format("%s: %s", L["Stealth"], L["|cffff4646[Swapping in stealth and during stuns!]|r"]));
	end
	if (RSwapper3.db.char.Dance) then
		self:AddLine(format("%s: %s", L["Dance"], L["|cff00ff00[On]|r"]));
	else
		self:AddLine(format("%s: %s", L["Dance"], L["|cffff0000[Off]|r"]));
	end
	if (RSwapper3.db.char.Blind) then
		self:AddLine(format("%s: %s", L["BlindOption"], L["|cff00ff00[On]|r"]));
	else
		self:AddLine(format("%s: %s", L["BlindOption"], L["|cffff0000[Off]|r"]));
	end
end

function dataobj:OnClick(button)
	if (not RSwapper3.ISCHARROGUE) then
		return;
	end
	GameTooltip:Hide();
	ToggleDropDownMenu(1, nil, RSwapper3.Menu, self, 0, 0);
end

function dataobj:OnEnter()
	GameTooltip:SetOwner(self, "ANCHOR_NONE");
	GameTooltip:SetPoint("TOPLEFT", self, "BOTTOMLEFT");
	GameTooltip:ClearLines();
	dataobj.OnTooltipShow(GameTooltip);
	GameTooltip:Show();
end

function dataobj:OnLeave()
	GameTooltip:Hide();
end

local menuitem = {};

RSwapper3.Menu = CreateFrame("Frame", "RSwapper3Menu")
RSwapper3.Menu.displayMode = "MENU"

RSwapper3.Menu.initialize = function(self, level)
	if (not level) then
		return;
	end
	wipe(menuitem);
	if (level == 1) then
		menuitem.isTitle = 1;
		menuitem.text = "RSwapper3";
		menuitem.notCheckable = 1;
		UIDropDownMenu_AddButton(menuitem, level);
		
		menuitem.disabled	= nil;
		menuitem.isTitle	= nil;
		menuitem.notCheckable	= nil;
		
		menuitem.text = GAMEOPTIONS_MENU;
		menuitem.func = RS3GUI.Toggle;
		menuitem.checked = nil;
		UIDropDownMenu_AddButton(menuitem, level);
		
		menuitem.text = L["Enable"];
		menuitem.func = RSwapper3.SetEnable;
		menuitem.checked = RSwapper3.db.char.Enable;
		UIDropDownMenu_AddButton(menuitem, level);
		
		menuitem.text = SOUND_LABEL;
		menuitem.func = RSwapper3.SetSound;
		menuitem.checked = RSwapper3.db.char.Sound;
		UIDropDownMenu_AddButton(menuitem, level);
		
		menuitem.text = L["Offhand"];
		menuitem.func = RSwapper3.SetOffhand;
		menuitem.checked = RSwapper3.db.char.Offhand;
		UIDropDownMenu_AddButton(menuitem, level);
		
		menuitem.text = L["Stealth"];
		menuitem.func = RSwapper3.SetStealth;
		menuitem.checked = RSwapper3.db.char.Stealth;
		UIDropDownMenu_AddButton(menuitem, level);
		
		menuitem.text = L["Dance"];
		menuitem.func = RSwapper3.SetDance;
		menuitem.checked = RSwapper3.db.char.Dance;
		UIDropDownMenu_AddButton(menuitem, level);
		
		menuitem.text = L["BlindOption"];
		menuitem.func = RSwapper3.SetBlind;
		menuitem.checked = RSwapper3.db.char.Blind;
		UIDropDownMenu_AddButton(menuitem, level);
		
		menuitem.text		= CLOSE;
		menuitem.func		= function() CloseDropDownMenus() end;
		menuitem.checked	= nil;
		menuitem.notCheckable	= 1;
		UIDropDownMenu_AddButton(menuitem, level);
	end
end